//+------------------------------------------------------------------+
//|    Copyright  2007-2016, Tradingsystemforex.com - Elite Section |
//|                              http://www.tradingsystemforex.com/  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007-2016, Tradingsystemforex.com - Elite Section"
#property link "http://www.tradingsystemforex.com/"

#property  indicator_separate_window

#property  indicator_buffers 4
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_color3  LimeGreen
#property  indicator_color4  DarkOrange
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_style1  STYLE_SOLID
#property  indicator_style2  STYLE_SOLID
#property  indicator_style3  STYLE_SOLID
#property  indicator_style4  STYLE_SOLID
#property indicator_minimum 0
#property indicator_maximum 1

extern int TimeFrame = 0;
extern int    CountBars = 400;
extern int     MA_Price   =6; //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
extern int     MA_Length  =1; //MA's Period 
extern int     MA_Mode    =0; //MA's Method:0-SMA,1-EMA,2-SMMA,3-LWMA  
extern int     ATR_Length =10;//ATR's Period
extern double  Kv         =1; //Volatility's Factor or Multiplier
extern double  MoneyRisk  =1; //Offset Factor 
extern bool    usePrice_HiLoBreak    =false;
extern bool    useMA_HiLoEnvelope    =false;
extern int     AlertMode  =1; //0-alert off,1-on
int     VisualMode =0; //0-lines,1-dots 
extern string Applied_Price_ ="0-C,1-O,2-H,3-L,4-Median(H+L)/2,5-Typical(H+L+C)/3,6-Weighted(H+L+C+C)/4";
extern string MAmethod_mode_ ="0-SMA,1-EMA,2-SMMA,3-LWMA";
extern string Visual_Mode___ ="0-lines,1-dots ";

//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];

int shift;
string Message="";
bool UpTrendAlert=false,DownTrendAlert=false;
int tf;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,4);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);

   SetIndexBuffer(0,ind_buffer1);
   SetIndexBuffer(1,ind_buffer2);
   SetIndexBuffer(2,ind_buffer3);
   SetIndexBuffer(3,ind_buffer4);

   IndicatorShortName("(TF "+IntegerToString(TimeFrame)+")");
   SetIndexLabel(0,"ind1");
   SetIndexLabel(1,"ind2");
   SetIndexLabel(2,"ind3");
   SetIndexLabel(3,"ind4");

   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars>0) counted_bars--;
   limit=CountBars;//Bars-counted_bars;
   
   limit += TimeFrame/Period() + 1;
   

   for(int i=0; i<limit; i++)
   {
      shift = iBarShift(NULL, TimeFrame, Time[i]);
      //ind_buffer1[i]=iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,Applied_Price_,MAmethod_mode_,Visual_Mode___,0,shift);
      //ind_buffer2[i]=iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,Applied_Price_,MAmethod_mode_,Visual_Mode___,1,shift);
      //ind_buffer3[i]=iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,Applied_Price_,MAmethod_mode_,Visual_Mode___,2,shift);
      //ind_buffer4[i]=iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,AlertMode,VisualMode,Applied_Price_,MAmethod_mode_,Visual_Mode___,3,shift);
   
      if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,0,shift)!=EMPTY_VALUE)ind_buffer1[i]=1;
      if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,1,shift)!=EMPTY_VALUE)ind_buffer2[i]=1;
      if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,2,shift)!=EMPTY_VALUE)ind_buffer3[i]=1;
      if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,3,shift)!=EMPTY_VALUE)ind_buffer4[i]=1;
      //if(ind_buffer2[i]!=EMPTY_VALUE)ind_buffer2[i]=1;
      //if(ind_buffer3[i]!=EMPTY_VALUE)ind_buffer3[i]=1;
      //if(ind_buffer4[i]!=EMPTY_VALUE)ind_buffer4[i]=1;
   
   }
   
   if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,2,1)!=EMPTY_VALUE
   && UpTrendAlert==false)
     {
      if(TimeFrame==0)tf=(int)Period();
      else tf=TimeFrame;
      Message=" "+Symbol()+" TF"+IntegerToString(tf)+" UP";
      if(AlertMode>0)Alert (Message);
      PlaySound("alert.wav");
      UpTrendAlert=true;
      DownTrendAlert=false;
     }
   if(iCustom(NULL,TimeFrame,"VoltyChannel_Stop_v2.1",MA_Price,MA_Length,MA_Mode,ATR_Length,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,3,1)!=EMPTY_VALUE
   && DownTrendAlert==false)
     {
      if(TimeFrame==0)tf=(int)Period();
      else tf=TimeFrame;
      Message=" "+Symbol()+" TF"+IntegerToString(tf)+" DN";
      if(AlertMode>0)Alert (Message);
      PlaySound("alert.wav");
      DownTrendAlert=true;
      UpTrendAlert=false;
     }

   return(0);
  }